/*---------------------------------------------------------------------------
  This code is part of the book
  LOGIC PROGRAMMING TECHNIQUES: THE PROLOG LANGUAGE
  Ilias Sakellariou, Nikos Bassiliades, Petros Kefalas, Demosthenes Stamatis
  Hellenic Academic On-line Publications, 2015
----------------------------------------------------------------------------*/

derivative(X, X, 1).               % dx/dx=1
derivative(C, X, 0) :-             % dc/dx=0 if c*x
  atomic(C), X\=C.
derivative(sin(X), X, cos(X)).    % dsin(x)/dx=cos(x)
derivative(cos(X), X, -sin(X)).    % dcos(x)/dx=-sin(x)
derivative(U+V, X, DU+DV) :-        % d(u+v)/dx=du/dx+dv/dx
  derivative(U, X, DU),
  derivative(V, X, DV).
derivative(U*V, X, V*DU+U*DV) :-    % d(u*v)/dx=v*du/dx+u*dv/dx
  derivative(U, X, DU),
  derivative(V, X, DV).
