/*---------------------------------------------------------------------------
  This code is part of the book
  LOGIC PROGRAMMING TECHNIQUES: THE PROLOG LANGUAGE
  Ilias Sakellariou, Nikos Bassiliades, Petros Kefalas, Demosthenes Stamatis
  Hellenic Academic On-line Publications, 2015
----------------------------------------------------------------------------*/

simplify(A + 0, A1) :- 
  simplify(A, A1).
simplify(0 + B, B1) :- 
  simplify(B, B1).
simplify(A + B, E) :-
  simplify(A, A1),
  simplify(B, B1),
  (A1 \= A; B1 \= B),
  simplify(A1 + B1, E).

% similarly with other arithmetic operations 

simplify(A^0, 1).
simplify(A^1, A1) :- 
  simplify(A, A1).
simplify(0^E, 0).
simplify(1^E, 1).
simplify(A^B, E) :-
  simplify(A, A1),
  simplify(B, B1),
  (A1 \= A; B1 \= B),
  simplify(A1^B1, E).
simplify(-(-(A)), A1) :- 
  simplify(A, A1).
simplify(A, A).